#include <allegro.h>
#include <winalleg.h>
#include "capture.h"
#include "editor.h"
void init();
void deinit();

volatile int frame_counter = 0;

void my_timer_handler()
{
    frame_counter++;
}


int main()
{
	init();
	editor_window();
	deinit();
	return 0;
}
END_OF_MAIN()



void init()
{
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
    set_window_title("Sound Compressor");
	
	detect_digi_driver(DIGI_AUTODETECT);
	if (install_sound(DIGI_DIRECTX(0), MIDI_NONE, NULL) == -1) {
       allegro_message(allegro_error);
       exit(-1);
    }
	if (install_sound_input(DIGI_DIRECTX(0), MIDI_NONE) != 0) {
       allegro_message(allegro_error);
       exit(-1);
    }
	install_timer();
	install_keyboard();
	install_mouse();
	
    LOCK_VARIABLE(frame_counter);
    LOCK_FUNCTION(my_timer_handler);
	install_int(my_timer_handler, 250);
	
    show_mouse(screen);
	/* add other initializations here */
}



void deinit()
{
	clear_keybuf();
	/* add other deinitializations here */
}
